'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _eventemitter = require('eventemitter3');

var _eventemitter2 = _interopRequireDefault(_eventemitter);

var _decode = require('./decode');

var _decode2 = _interopRequireDefault(_decode);

var _encode = require('./encode');

var _encode2 = _interopRequireDefault(_encode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Socket = function (_EventEmitter) {
  (0, _inherits3.default)(Socket, _EventEmitter);

  function Socket(config) {
    (0, _classCallCheck3.default)(this, Socket);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Socket.__proto__ || Object.getPrototypeOf(Socket)).call(this));

    _this._config = config;
    return _this;
  }

  (0, _createClass3.default)(Socket, [{
    key: 'connect',
    value: function connect() {
      var _this2 = this;

      var socket = void 0;
      if (typeof WebSocket === 'undefined') {
        throw new Error('\'WebSocket\' is undefined. Have you ever include any websocket polyfill?');
      } else if (WebSocket.length === 1) {
        socket = new WebSocket(this._config.url);
      } else {
        var options = {};
        if (this._config.origin) options.origin = this._config.origin;
        socket = new WebSocket(this._config.url, options);
      }
      socket.addEventListener('open', this.emit.bind(this, 'connect'));
      socket.addEventListener('close', this.emit.bind(this, 'disconnect'));
      socket.addEventListener('error', this.emit.bind(this, 'error'));

      var buffer = [];
      var timeoutHandler = void 0;
      socket.binaryType = "arraybuffer";
      socket.addEventListener('message', function (_ref) {
        var _buffer;

        var data = _ref.data;

        clearTimeout(timeoutHandler);
        (_buffer = buffer).push.apply(_buffer, (0, _toConsumableArray3.default)(new Uint8Array(data)));
        timeoutHandler = setTimeout(function () {
          _this2.emit('message', (0, _decode2.default)(buffer, _this2._config));
          buffer = [];
        }, _this2._config.timeout);
        if (data.byteLength > _this2._config.blobSize) {
          throw new Error('Receive message length(' + data.byteLength + ') greater than buffer size(' + _this2._config.blobSize + ')');
        }
      });

      this._socket = socket;
    }
  }, {
    key: 'send',
    value: function send(str) {
      var socket = this._socket;
      socket.send((0, _encode2.default)(str));
    }
  }]);
  return Socket;
}(_eventemitter2.default);

exports.default = Socket;