'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _eventemitter = require('eventemitter3');

var _eventemitter2 = _interopRequireDefault(_eventemitter);

var _sleepPromise = require('sleep-promise');

var _sleepPromise2 = _interopRequireDefault(_sleepPromise);

var _terminal = require('terminal.js');

var _terminal2 = _interopRequireDefault(_terminal);

var _keyboard = require('../../utils/keyboard');

var _keyboard2 = _interopRequireDefault(_keyboard);

var _char = require('../../utils/char');

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var setIntevalUntil = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(_func, _validate, _inteval) {
    var ret;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _sleepPromise2.default)(_inteval);

          case 2:
            _context.next = 4;
            return _func();

          case 4:
            ret = _context.sent;

            if (!_validate(ret)) {
              _context.next = 9;
              break;
            }

            return _context.abrupt('return', ret);

          case 9:
            return _context.abrupt('return', setIntevalUntil(_func, _validate, _inteval));

          case 10:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function setIntevalUntil(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

var Bot = function (_EventEmitter) {
  (0, _inherits3.default)(Bot, _EventEmitter);

  function Bot(config) {
    (0, _classCallCheck3.default)(this, Bot);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Bot.__proto__ || Object.getPrototypeOf(Bot)).call(this));

    _this.getLine = function (n) {
      return _this._term.state.getLine(n);
    };

    config = (0, _extends3.default)({}, _config2.default, config);

    _this._term = new _terminal2.default(config.terminal);
    _this._state = (0, _extends3.default)({}, Bot.initialState);
    _this._term.state.setMode('stringWidth', 'dbcs');

    var Socket = void 0;
    switch (config.protocol.toLowerCase()) {
      case 'websocket':
      case 'ws':
      case 'wss':
        Socket = require("../../core/socket").default;
        break;
      case 'telnet':
      case 'ssh':
      default:
        Socket = null;
    }

    if (Socket === null) {
      throw 'Invalid protocol: ' + config.protocol;
    }

    var socket = new Socket(config);
    socket.connect();

    Bot.forwardEvents.forEach(function (e) {
      socket.on(e, _this.emit.bind(_this, e));
    });
    socket.on('message', function (msg) {
      _this._term.write(msg);
      _this.emit('redraw', _this._term.toString());
    }).on('disconnect', function (close) {}).on('error', function (err) {
      console.log(err);
    });
    _this.socket = socket;
    _this.config = config;
    return _this;
  }

  (0, _createClass3.default)(Bot, [{
    key: 'send',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(msg) {
        var _this2 = this;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                this.config.preventIdle && this.preventIdle();
                return _context2.abrupt('return', new Promise(function (resolve) {
                  _this2.socket.send(msg);
                  _this2.once('message', function (msg) {
                    resolve(msg);
                  });
                }));

              case 2:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function send(_x4) {
        return _ref2.apply(this, arguments);
      }

      return send;
    }()
  }, {
    key: 'preventIdle',
    value: function preventIdle() {
      var _this3 = this;

      var timeout = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 60;

      clearTimeout(this.preventIdleHandler);
      this.preventIdleHandler = setTimeout(function () {
        _this3.send('' + _keyboard2.default.CtrlU + _keyboard2.default.ArrowLeft);
      }, timeout * 1000);
    }
  }, {
    key: 'login',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(username, password) {
        var ret, state;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!this._state.login) {
                  _context3.next = 2;
                  break;
                }

                return _context3.abrupt('return');

              case 2:
                username = username.replace(/,/g, '');
                _context3.next = 5;
                return this.send(username + ',' + _keyboard2.default.Enter + password + _keyboard2.default.Enter);

              case 5:
                ret = void 0;

              case 6:
                _context3.next = 8;
                return this._checkLogin();

              case 8:
                _context3.t0 = ret = _context3.sent;

                if (!(_context3.t0 === null)) {
                  _context3.next = 14;
                  break;
                }

                _context3.next = 12;
                return (0, _sleepPromise2.default)(400);

              case 12:
                _context3.next = 6;
                break;

              case 14:
                if (ret) {
                  state = this._state;

                  state.login = true;
                  state.position = {
                    boardname: ""
                  };
                  this.emit('stateChange', this.state);
                }
                return _context3.abrupt('return', ret);

              case 16:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function login(_x6, _x7) {
        return _ref3.apply(this, arguments);
      }

      return login;
    }()
  }, {
    key: '_checkLogin',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
        var getLine;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                getLine = this.getLine;

                if (!getLine(21).str.includes("密碼不對或無此帳號")) {
                  _context4.next = 6;
                  break;
                }

                this.emit('login.failed');
                return _context4.abrupt('return', false);

              case 6:
                if (!(getLine(22).str + getLine(23).str).toLowerCase().includes("y/n")) {
                  _context4.next = 11;
                  break;
                }

                _context4.next = 9;
                return this.send('y' + _keyboard2.default.Enter);

              case 9:
                _context4.next = 33;
                break;

              case 11:
                if (!getLine(23).str.includes("請勿頻繁登入以免造成系統過度負荷")) {
                  _context4.next = 16;
                  break;
                }

                _context4.next = 14;
                return this.send('' + _keyboard2.default.Enter);

              case 14:
                _context4.next = 33;
                break;

              case 16:
                if (!getLine(23).str.includes("按任意鍵繼續")) {
                  _context4.next = 21;
                  break;
                }

                _context4.next = 19;
                return this.send('' + _keyboard2.default.Enter);

              case 19:
                _context4.next = 33;
                break;

              case 21:
                if (!getLine(23).str.includes("您要刪除以上錯誤嘗試的記錄嗎")) {
                  _context4.next = 26;
                  break;
                }

                _context4.next = 24;
                return this.send('y' + _keyboard2.default.Enter);

              case 24:
                _context4.next = 33;
                break;

              case 26:
                if (!getLine(23).str.includes("我是")) {
                  _context4.next = 31;
                  break;
                }

                this.emit('login.success');
                return _context4.abrupt('return', true);

              case 31:
                _context4.next = 33;
                return this.send('q');

              case 33:
                return _context4.abrupt('return', null);

              case 34:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function _checkLogin() {
        return _ref4.apply(this, arguments);
      }

      return _checkLogin;
    }()
  }, {
    key: 'getArticles',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(boardname) {
        var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

        var getLine, articles, i, line, article, _i, _i2;

        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this.enterBoard(boardname);

              case 2:
                offset |= 0;

                if (!(offset > 0)) {
                  _context5.next = 7;
                  break;
                }

                offset = Math.max(offset - 9, 1);
                _context5.next = 7;
                return this.send('' + _keyboard2.default.End + _keyboard2.default.End + offset + _keyboard2.default.Enter);

              case 7:
                getLine = this.getLine;
                articles = [];

                for (i = 3; i <= 22; i++) {
                  line = getLine(i).str;
                  article = {
                    sn: (0, _char.substrWidth)('dbcs', line, 1, 7).trim() | 0,
                    push: (0, _char.substrWidth)('dbcs', line, 9, 2).trim(),
                    date: (0, _char.substrWidth)('dbcs', line, 11, 5).trim(),
                    author: (0, _char.substrWidth)('dbcs', line, 17, 12).trim(),
                    status: (0, _char.substrWidth)('dbcs', line, 30, 2).trim(),
                    title: (0, _char.substrWidth)('dbcs', line, 32).trim(),
                    fixed: (0, _char.substrWidth)('dbcs', line, 1, 7).trim().includes('★')
                  };

                  articles.push(article);
                }
                // fix sn

                if (!(articles.length >= 2 && articles[0].sn === 0)) {
                  _context5.next = 19;
                  break;
                }

                _i = 1;

              case 12:
                if (!(_i < articles.length)) {
                  _context5.next = 19;
                  break;
                }

                if (!(articles[_i].sn !== 0)) {
                  _context5.next = 16;
                  break;
                }

                articles[0].sn = articles[_i].sn - _i;
                return _context5.abrupt('break', 19);

              case 16:
                _i++;
                _context5.next = 12;
                break;

              case 19:
                for (_i2 = 1; _i2 < articles.length; _i2++) {
                  articles[_i2].sn = articles[_i2 - 1].sn + 1;
                }
                _context5.next = 22;
                return this.enterIndex();

              case 22:
                return _context5.abrupt('return', articles.reverse());

              case 23:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function getArticles(_x8) {
        return _ref5.apply(this, arguments);
      }

      return getArticles;
    }()
  }, {
    key: 'getArticle',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(boardname, sn) {
        var getLine, article, i, lastLine, _i3, j;

        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this.enterBoard(boardname);

              case 2:
                getLine = this.getLine;
                _context6.next = 5;
                return this.send('' + sn + _keyboard2.default.Enter + _keyboard2.default.Enter);

              case 5:
                article = {
                  sn: sn,
                  author: (0, _char.substrWidth)('dbcs', getLine(0).str, 7, 50).trim(),
                  title: (0, _char.substrWidth)('dbcs', getLine(1).str, 7).trim(),
                  timestamp: (0, _char.substrWidth)('dbcs', getLine(2).str, 7).trim(),
                  lines: []
                };


                article.lines.push(getLine(0).str);

              case 7:
                if (getLine(23).str.includes("100%")) {
                  _context6.next = 13;
                  break;
                }

                for (i = 1; i < 23; i++) {
                  article.lines.push(getLine(i).str);
                }
                _context6.next = 11;
                return this.send(_keyboard2.default.PgDown);

              case 11:
                _context6.next = 7;
                break;

              case 13:
                lastLine = article.lines[article.lines.length - 1];
                _i3 = 0;

              case 15:
                if (!(_i3 < 23)) {
                  _context6.next = 22;
                  break;
                }

                if (!(getLine(_i3).str == lastLine)) {
                  _context6.next = 19;
                  break;
                }

                for (j = _i3 + 1; j < 23; j++) {
                  article.lines.push(getLine(j).str);
                }
                return _context6.abrupt('break', 22);

              case 19:
                _i3++;
                _context6.next = 15;
                break;

              case 22:
                _context6.next = 24;
                return this.enterIndex();

              case 24:
                return _context6.abrupt('return', article);

              case 25:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function getArticle(_x10, _x11) {
        return _ref6.apply(this, arguments);
      }

      return getArticle;
    }()
  }, {
    key: 'getFavorite',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7() {
        var getLine, favorites, i, line, favorite;
        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return this.enterFavorite();

              case 2:
                getLine = this.getLine;
                favorites = [];
                i = 3;

              case 5:
                if (!(i < 23)) {
                  _context7.next = 22;
                  break;
                }

                line = getLine(i).str;

                if (!(line.trim() === '')) {
                  _context7.next = 9;
                  break;
                }

                return _context7.abrupt('break', 22);

              case 9:
                favorite = {
                  bn: (0, _char.substrWidth)('dbcs', line, 3, 4).trim() | 0,
                  read: (0, _char.substrWidth)('dbcs', line, 8, 2).trim() === '',
                  boardname: (0, _char.substrWidth)('dbcs', line, 10, 12).trim(),
                  category: (0, _char.substrWidth)('dbcs', line, 23, 4).trim(),
                  title: (0, _char.substrWidth)('dbcs', line, 30, 31),
                  users: (0, _char.substrWidth)('dbcs', line, 62, 5).trim(),
                  admin: (0, _char.substrWidth)('dbcs', line, 67).trim(),
                  folder: false,
                  divider: false
                };
                _context7.t0 = favorite.boardname;
                _context7.next = _context7.t0 === 'MyFavFolder' ? 13 : _context7.t0 === '------------' ? 15 : 17;
                break;

              case 13:
                favorite = (0, _extends3.default)({}, favorite, {
                  title: (0, _char.substrWidth)('dbcs', line, 30),
                  users: '',
                  admin: '',
                  folder: true
                });
                return _context7.abrupt('break', 18);

              case 15:
                favorite = (0, _extends3.default)({}, favorite, {
                  title: (0, _char.substrWidth)('dbcs', line, 30),
                  users: '',
                  admin: '',
                  divider: true
                });
                return _context7.abrupt('break', 18);

              case 17:
                return _context7.abrupt('break', 18);

              case 18:
                favorites.push(favorite);

              case 19:
                i++;
                _context7.next = 5;
                break;

              case 22:
                _context7.next = 24;
                return this.enterIndex();

              case 24:
                return _context7.abrupt('return', favorites);

              case 25:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function getFavorite() {
        return _ref7.apply(this, arguments);
      }

      return getFavorite;
    }()
  }, {
    key: 'enterIndex',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8() {
        return _regenerator2.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return this.send('' + _keyboard2.default.ArrowLeft.repeat(10));

              case 2:
                return _context8.abrupt('return', true);

              case 3:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function enterIndex() {
        return _ref8.apply(this, arguments);
      }

      return enterIndex;
    }()
  }, {
    key: 'enterBoard',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9(boardname) {
        var getLine;
        return _regenerator2.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return this.send('s' + boardname + _keyboard2.default.Enter + ' ' + _keyboard2.default.Home + _keyboard2.default.End);

              case 2:
                boardname = boardname.toLowerCase();
                getLine = this.getLine;

                if (!getLine(23).str.includes("按任意鍵繼續")) {
                  _context9.next = 7;
                  break;
                }

                _context9.next = 7;
                return this.send(' ');

              case 7:
                if (!getLine(0).str.toLowerCase().includes('' + boardname)) {
                  _context9.next = 11;
                  break;
                }

                this._state.position.boardname = boardname;
                this.emit('stateChange', this.state);
                return _context9.abrupt('return', true);

              case 11:
                return _context9.abrupt('return', false);

              case 12:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function enterBoard(_x12) {
        return _ref9.apply(this, arguments);
      }

      return enterBoard;
    }()
  }, {
    key: 'enterFavorite',
    value: function () {
      var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee10() {
        return _regenerator2.default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                _context10.next = 2;
                return this.send('F' + _keyboard2.default.Enter);

              case 2:
                return _context10.abrupt('return', true);

              case 3:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function enterFavorite() {
        return _ref10.apply(this, arguments);
      }

      return enterFavorite;
    }()
  }, {
    key: 'state',
    get: function get() {
      return (0, _extends3.default)({}, this._state);
    }
  }]);
  return Bot;
}(_eventemitter2.default);

Bot.initialState = {
  login: false
};
Bot.forwardEvents = ['connect', 'disconnect', 'message', 'error'];
exports.default = Bot;